﻿Imports System.Windows.Data
Imports System.IO
Imports System.Windows.Media.Imaging
Imports WCFImages.ImageService

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()

        Dim client As WCFServiceClient = New WCFServiceClient()
        AddHandler client.GetAllEmpCompleted, AddressOf client_GetAllEmpCompleted
        client.GetAllEmpAsync()

    End Sub

    Private Sub client_GetAllEmpCompleted(sender As Object, e As GetAllEmpCompletedEventArgs)
        C1DataGrid1.ItemsSource = e.Result
    End Sub

End Class

' Implements ‘IValueConverter’ interface and its methods. 
'     * The ‘Convert’ method reads byte array and converts it into a memory stream. 
'     * This memory stream is then bound with the ‘BitMapImage’ so that it can be 
'     * further bound with the Image UI element.

Public Class ImageConverter
    Implements IValueConverter


    Public Function Convert(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
        Dim imageBytes = DirectCast(value, Byte())
        Dim memStream As New MemoryStream(imageBytes, False)
        Dim _image As New BitmapImage()
        _image.SetSource(memStream)
        Return _image
    End Function

    Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
